<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "ehr_patient".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "EhrPatient".
 *
 * Columns in table "ehr_patient" available as properties of the model,
 * followed by relations of table "ehr_patient" available as properties of the model.
 *
 * @property integer $id
 * @property string $ehr_patient_id
 * @property integer $cpn_ehr_installation_id
 * @property integer $patient_id
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property CpnEhrInstallation $cpnEhrInstallation
 * @property Account $addedByAccount
 * @property Patient $patient
 */
abstract class BaseEhrPatient extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'ehr_patient';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'EhrPatient|EhrPatients', $n);
    }

    public static function representingColumn()
    {
        return 'ehr_patient_id';
    }

    public function rules()
    {
        return array(
            array('ehr_patient_id, cpn_ehr_installation_id, patient_id, added_by_account_id', 'required'),
            array('cpn_ehr_installation_id, patient_id, added_by_account_id, updated_by_account_id', 'numerical',
                'integerOnly' => true),
            array('ehr_patient_id', 'length', 'max' => 50),
            array('date_added, date_updated', 'safe'),
            array('date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, ehr_patient_id, cpn_ehr_installation_id, patient_id, date_added, added_by_account_id, '
                . 'date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnEhrInstallation' => array(self::BELONGS_TO, 'CpnEhrInstallation', 'cpn_ehr_installation_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'patient' => array(self::BELONGS_TO, 'Patient', 'patient_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'ehr_patient_id' => Yii::t('app', 'Ehr Patient'),
            'cpn_ehr_installation_id' => null,
            'patient_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'cpnEhrInstallation' => null,
            'addedByAccount' => null,
            'patient' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('ehr_patient_id', $this->ehr_patient_id, true);
        $criteria->compare('cpn_ehr_installation_id', $this->cpn_ehr_installation_id);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
